
/* dont change anything below this line unless you know what you are doing :-) */
var offsetToZeroH = -80;
var offsetToZeroM = -80;
var offsetToZeroS =	-80;
var lineHeight = 40;

var d = new Date();

function initiate () {
	document.getElementById("main-wrapper").style.opacity = '1';
	
	var initialTime = calculateTimeInitial();
	
	setTimeout(function () { // creates initial waiting delay
		document.getElementById("hours").style.webkitTransform = 'translate(0px, ' + initialTime[0] + 'px)';
		document.getElementById("minutes").style.webkitTransform = 'translate(0px, ' + initialTime[1] + 'px)';
		document.getElementById("seconds").style.webkitTransform = 'translate(0px, ' + initialTime[2] + 'px)';
	}, 1000);
	
	setTimeout(update, 4000);
}


var HposOld = null;
var MposOld = null;
var SposOld = null;

function update () {
	d = new Date();

	var currentTime = calculateTime();
	
	HposNew = currentTime[0];
	MposNew = currentTime[1];
	SposNew = currentTime[2];
	
	if (HposNew == offsetToZeroH && HposOld != offsetToZeroH && HposOld != null) { // if one cycle of clock is done, reset will occur
		HposReset = HposNew + lineHeight;
		
		document.getElementById("hours").style.webkitTransitionDuration = '0s';
		document.getElementById("hours").style.webkitTransform = 'translate(0px, ' + HposReset + 'px)';			
	
		setTimeout(function () { // wait for redraw
			document.getElementById("hours").style.webkitTransitionDuration = '4s';
			document.getElementById("hours").style.webkitTransform = 'translate(0px, ' + HposNew + 'px)';
			
		}, 1);
		HposOld = HposNew;	
	} else if (HposOld < HposNew) {
		document.getElementById("hours").style.webkitTransform = 'translate(0px, ' + HposNew + 'px)';
		
		HposOld = HposNew;	
	} else if (HposOld != HposNew) { // protection to prevent unnecessary cpu activity
		document.getElementById("hours").style.webkitTransform = 'translate(0px, ' + HposNew + 'px)';
		
		HposOld = HposNew;
	}
	
	if (MposNew == offsetToZeroM && MposOld != offsetToZeroM && MposOld != null) {
		MposReset = MposNew + lineHeight;
		
		document.getElementById("minutes").style.webkitTransitionDuration = '0s';
		document.getElementById("minutes").style.webkitTransform = 'translate(0px, ' + MposReset + 'px)';

		setTimeout(function () { // wait for redraw
			document.getElementById("minutes").style.webkitTransitionDuration = '3s';
			document.getElementById("minutes").style.webkitTransform = 'translate(0px, ' + MposNew + 'px)';			
		}, 1);
		
		MposOld = MposNew;
	} else if (MposOld < MposNew) {
		document.getElementById("minutes").style.webkitTransform = 'translate(0px, ' + MposNew + 'px)';	
		
		MposOld = MposNew;	
	} else if (MposOld != MposNew) {
		document.getElementById("minutes").style.webkitTransform = 'translate(0px, ' + MposNew + 'px)';	
		
		MposOld = MposNew;
	}
	
	if (SposNew == offsetToZeroS && SposOld != offsetToZeroS && SposOld != null) { // normal reset of clock
		SposReset = SposNew + lineHeight;

		document.getElementById("seconds").style.webkitTransitionDuration = '0s';		
		document.getElementById("seconds").style.webkitTransform = 'translate(0px, ' + SposReset + 'px)';

		setTimeout(function () { // wait for redraw
			document.getElementById("seconds").style.webkitTransitionDuration = '0.9s';	
			document.getElementById("seconds").style.webkitTransform = 'translate(0px, ' + SposNew + 'px)';
		}, 1);	
		
		SposOld = SposNew;	
	} else if (SposOld < SposNew) { // special case to execute when script was sleeping for a long time
		document.getElementById("seconds").style.webkitTransitionDuration = '0.9s';
	
		document.getElementById("seconds").style.webkitTransform = 'translate(0px, ' + SposNew + 'px)';
		
		SposOld = SposNew;		
	} else if (SposOld != SposNew) { // proper transition
		document.getElementById("seconds").style.webkitTransitionDuration = '0.9s';
	
		document.getElementById("seconds").style.webkitTransform = 'translate(0px, ' + SposNew + 'px)';
		
		SposOld = SposNew;	
	}
	
	setTimeout(update, 1000);
}

function calculateTimeInitial () {
	var hours = d.getHours();
	var minutes = d.getMinutes();
	var seconds = d.getSeconds() + 4;	
	
	if (seconds >= 60) {
		seconds = seconds - 60;
		
		minutes = minutes + 1;
		
		if (minutes == 60) {
			minutes = 0;
			
			hours = hours + 1;
			
			if (hours == 24) {
				hours = 0;
			}
		}
	}

	var currentPositionH = offsetToZeroH - (lineHeight * hours);
	var currentPositionM = offsetToZeroM - (lineHeight * minutes);
	var currentPositionS = offsetToZeroS - (lineHeight * seconds);
	
	var output = new Array(currentPositionH, currentPositionM, currentPositionS);
	
	return output;
}


function calculateTime () {
	var hours = d.getHours();
	var minutes = d.getMinutes();
	var seconds = d.getSeconds();
	
	var currentPositionH = offsetToZeroH - (lineHeight * hours);
	var currentPositionM = offsetToZeroM - (lineHeight * minutes);
	var currentPositionS = offsetToZeroS - (lineHeight * seconds);

	var output = new Array(currentPositionH, currentPositionM, currentPositionS);
	
	return output;
}